## mingw-w64-tulip-5.7.4-3.src.tar.zst

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 3.12)

#Setting project name and version (W.X.Y.Z if necessary)
CMAKE_POLICY(SET CMP0048 NEW)
PROJECT(Tulip VERSION 5.7.4 DESCRIPTION "Large graphs analysis and drawing" HOMEPAGE_URL "https://tulip.labri.fr")
message(STATUS "Configuring ${CMAKE_PROJECT_NAME} ${Tulip_VERSION}")

# First display CMake version
MESSAGE(STATUS "Using CMake ${CMAKE_VERSION}")

# Remove CMake warnings related to Qt5
CMAKE_POLICY(SET CMP0020 NEW)

# Needed by clang compiler provided by MacPorts or homebrew
CMAKE_POLICY(SET CMP0025 NEW)

# Remove CMake warnings related to rpath on MacOS
CMAKE_POLICY(SET CMP0042 NEW)
CMAKE_POLICY(SET CMP0068 NEW)

# allow FindOpenGL to use GLVND when available
CMAKE_POLICY(SET CMP0072 NEW)

# enable the use of ccache for Tulip developers to speed up the build process
IF(NOT MSVC)
  OPTION(TULIP_USE_CCACHE "Do you want to use ccache to speed up the build process during Tulip development ? [OFF|ON]" OFF)
  FIND_PROGRAM(CCACHE_PROGRAM ccache)
  IF(TULIP_USE_CCACHE AND CCACHE_PROGRAM)
      SET(CMAKE_CXX_COMPILER_LAUNCHER "${CCACHE_PROGRAM}")
      SET(CMAKE_C_COMPILER_LAUNCHER "${CCACHE_PROGRAM}")
  ENDIF(TULIP_USE_CCACHE AND CCACHE_PROGRAM)
ENDIF(NOT MSVC)

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

#convert CMAKE_INSTALL_PREFIX path into a cmake style path with unix /
#this is to avoid a path with a '\' as the last character which may be seen as
#an escape character (e.g. \")
FILE(TO_CMAKE_PATH "${CMAKE_INSTALL_PREFIX}" CMAKE_INSTALL_PREFIX)

# Force build type to release with debug info if none has been provided
IF(NOT MSVC AND "${CMAKE_BUILD_TYPE}" STREQUAL "")
  SET(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "" FORCE)
ENDIF(NOT MSVC AND "${CMAKE_BUILD_TYPE}" STREQUAL "")

## ========================================================
## Check processor architecture
## ========================================================
STRING(COMPARE EQUAL "${CMAKE_SIZEOF_VOID_P}" "8" IS_64BIT)
IF(IS_64BIT)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DIS_64BIT")
  IF(CMAKE_SYSTEM_PROCESSOR MATCHES "arm64")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DARM64")
  ELSE()
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DX86_64")
  ENDIF()
ENDIF(IS_64BIT)

## ========================================================
## Consider *BSD as Linux
## ========================================================
STRING(COMPARE EQUAL "${CMAKE_SYSTEM_NAME}" "Linux" LINUX)
IF(NOT LINUX)
  STRING(FIND "${CMAKE_SYSTEM_NAME}" "BSD" BSD_POS)
  IF(BSD_POS GREATER -1)
    SET(LINUX TRUE)
    SET(BSD TRUE)
  ENDIF()
ENDIF(NOT LINUX)

## ========================================================
## AppImage build
## ========================================================
IF (TULIP_BUILD_FOR_APPIMAGE)
  ADD_COMPILE_DEFINITIONS(APPIMAGE_BUILD)
ENDIF (TULIP_BUILD_FOR_APPIMAGE)

## ========================================================
## Install paths
## ========================================================

INCLUDE(GNUInstallDirs)

SET(TulipLibInstallDir ${CMAKE_INSTALL_LIBDIR})
SET(TulipPluginsInstallDir ${TulipLibInstallDir}/tulip)
SET(TulipGlyphPluginsInstallDir ${TulipPluginsInstallDir}/glyph)
SET(TulipViewPluginsInstallDir ${TulipPluginsInstallDir}/view)
SET(TulipInteractorPluginsInstallDir ${TulipPluginsInstallDir}/interactor)
SET(TulipPerspectivePluginsInstallDir ${TulipPluginsInstallDir}/perspective)
SET(TulipBinInstallDir ${CMAKE_INSTALL_BINDIR})
SET(TulipIncludeInstallDir ${CMAKE_INSTALL_INCLUDEDIR})
SET(TulipShareInstallDir ${CMAKE_INSTALL_DATADIR}/tulip)
SET(TulipBitmapInstallDir ${TulipShareInstallDir}/bitmaps)

## ========================================================
## Tulip CMake macros
## ========================================================
INCLUDE(cmake/TulipUseFile.cmake)

## ========================================================
## Tulip version variables
## ========================================================
SET(TulipVersionSeparator .)
IF(MSVC) #specific options for Visual Studio
  SET(TulipVersionSeparator _)
ENDIF()
SET(TulipMMVersion "${PROJECT_VERSION_MAJOR}${TulipVersionSeparator}${PROJECT_VERSION_MINOR}")
# Use two digits for the minor version when generating the Tulip integer version number
# as there was a 4.10 release that breaks preprocessor test like TULIP_INT_VERSION >= 4100 since the 5.0 release
# (see https://sourceforge.net/p/auber/bugs/869/)
STRING(LENGTH "${Tulip_VERSION_MINOR}" TulipMinorVersionNbDigits)
IF(TulipMinorVersionNbDigits LESS 2)
  SET(TulipMinorVersionTwoDigits "0${Tulip_VERSION_MINOR}")
ELSE(TulipMinorVersionNbDigits LESS 2)
  SET(TulipMinorVersionTwoDigits "${PROJECT_VERSION_MINOR}")
ENDIF(TulipMinorVersionNbDigits LESS 2)
SET(TulipIntMMVersion "${Tulip_VERSION_MAJOR}${TulipMinorVersionTwoDigits}")
SET(TulipIntVersion "${Tulip_VERSION_MAJOR}${TulipMinorVersionTwoDigits}${PROJECT_VERSION_PATCH}")

## ========================================================
## Tulip libraries names
## ========================================================
SET(LibTulipCoreName "tulip-core-${TulipMMVersion}")
SET(LibTulipOGLName "tulip-ogl-${TulipMMVersion}")
SET(LibTulipGUIName "tulip-gui-${TulipMMVersion}")
SET(LibTulipPythonName "tulip-python-${TulipMMVersion}")
SET(LibStlPythonBindingsName "stl-python-bindings")
SET(LibTulipCorePythonBindingsName "tulip-core-python-bindings")
SET(LibTulipGUIPythonBindingsName "tulip-gui-python-bindings")
SET(TulipLibs ${LibTulipCoreName} ${LibTulipOGLName} ${LibTulipGUIName})

## ========================================================
## Current year (used in documentation config files)
## ========================================================
STRING(TIMESTAMP CurrentYear "%Y")

## ========================================================
## Compiler-specific options
## ========================================================

TULIP_SET_COMPILER_OPTIONS()


## plugin server
OPTION(TULIP_GENERATE_PLUGINSERVER "Compile and install plugin server" OFF)

## ========================================================
## CORE ONLY
## this used to have a minimal build of Tulip without
## any of the opengl, qt or python components
## ========================================================
IF(NOT EXISTS ${PROJECT_SOURCE_DIR}/cmake/FindQtX.cmake OR EMSCRIPTEN)
  SET(TULIP_BUILD_CORE_ONLY ON)
  MESSAGE("You can only configure a core build of Tulip.")
ELSE()
  SET(TULIP_BUILD_CORE_ONLY OFF CACHE BOOL "Do you want a minimal build of Tulip (no OpenGL rendering, no Qt gui, no documentation) ? [ON|OFF]")
ENDIF()

IF(TULIP_BUILD_CORE_ONLY AND LINUX)
# the macro ADD_CORE_FILES will be used
# to collect the files needed to build a minimal Tulip
# in the directory pointed by CMAKE_CURRENT_SOURCE_DIR
  MACRO(ADD_CORE_FILES files)
    SET(CURRENT_SOURCE_DIR ".")
    IF(${CMAKE_CURRENT_SOURCE_DIR} STRGREATER ${PROJECT_SOURCE_DIR})
      EXECUTE_PROCESS(COMMAND echo -n ${CMAKE_CURRENT_SOURCE_DIR}
                      COMMAND sed "s,${PROJECT_SOURCE_DIR}/,,"
                      OUTPUT_VARIABLE CURRENT_SOURCE_DIR)
    ENDIF()
    IF(${files} STREQUAL ".")
      SET(ENV{CORE_FILES} "$ENV{CORE_FILES} \$(find ${CURRENT_SOURCE_DIR} -path \"*/.svn\" -prune -o -type f -print)")
    ELSE()
      FOREACH(core_file ${ARGV})
        SET(ENV{CORE_FILES} "$ENV{CORE_FILES} ${CURRENT_SOURCE_DIR}/${core_file}")
      ENDFOREACH()
    ENDIF()
  ENDMACRO()
  ADD_CORE_FILES(CMakeLists.txt cmake/cmake_uninstall.cmake.in cmake/TulipUseFile.cmake cmake/FindCppUnit.cmake cmake/FindTulip.cmake)
# the macro ADD_CORE_DIRECTORY_EXCEPT will be used
# to exclude the files not needed to build a minimal Tulip
# in the directory pointed by CMAKE_CURRENT_SOURCE_DIR
  MACRO(ADD_CORE_DIRECTORY_EXCEPT files)
    SET(CURRENT_SOURCE_DIR ".")
    IF(${CMAKE_CURRENT_SOURCE_DIR} STRGREATER ${PROJECT_SOURCE_DIR})
      EXECUTE_PROCESS(COMMAND echo -n ${CMAKE_CURRENT_SOURCE_DIR}
                      COMMAND sed "s,${PROJECT_SOURCE_DIR}/,,"
                      OUTPUT_VARIABLE CURRENT_SOURCE_DIR)
    ENDIF()
    SET(find_command "\$(find ${CURRENT_SOURCE_DIR} -path \"*/.svn\" -prune -o -type f")
    FOREACH(exclude_file ${ARGV})
      SET(find_command "${find_command} -a ! -name \"${exclude_file}\"")
    ENDFOREACH()
    SET(ENV{CORE_FILES} "$ENV{CORE_FILES} ${find_command} -print)")
  ENDMACRO()
ELSE()
  MACRO(ADD_CORE_FILES files)
  ENDMACRO()
  MACRO(ADD_CORE_DIRECTORY_EXCEPT files)
  ENDMACRO()
ENDIF()

IF (NOT TRAVIS_BUILD_THIRDPARTY_ONLY)
  SET(TULIP_BUILD_PYTHON_COMPONENTS ON CACHE BOOL "Do you want to build Tulip Python components ? [ON|OFF]")
  IF(TULIP_BUILD_PYTHON_COMPONENTS)
    SET(TULIP_PYTHON_ROOT_FOLDER ${CMAKE_BINARY_DIR}/library/tulip-python/bindings/tulip-core/tulip_module)
    SET(TULIP_PYTHON_FOLDER ${TULIP_PYTHON_ROOT_FOLDER}/tulip)
    SET(TULIPGUI_PYTHON_ROOT_FOLDER ${CMAKE_BINARY_DIR}/library/tulip-python/bindings/tulip-gui/tulipgui_module)
    SET(TULIPGUI_PYTHON_FOLDER ${TULIPGUI_PYTHON_ROOT_FOLDER}/tulipgui)
    SET(TULIP_PYTHON_NATIVE_FOLDER ${TULIP_PYTHON_FOLDER}/native)
    SET(TULIPGUI_PYTHON_NATIVE_FOLDER ${TULIPGUI_PYTHON_FOLDER}/native)
    SET(TULIP_ACTIVATE_PYTHON_WHEEL_TARGET OFF CACHE BOOL "Add a wheel make target for generating Python tulip-core module wheel ? [ON|OFF]")
    IF(TULIP_ACTIVATE_PYTHON_WHEEL_TARGET)
      SET(TULIP_BUILD_CORE_ONLY ON)
      IF(APPLE)
	# build binaries with install rpath when generating Tulip Python wheels
	# for MacOs as we don't install the project in that case
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
      ELSEIF(LINUX)
        FILE(READ /etc/centos-release LINUX_ISSUE)
	IF((NOT "${LINUX_ISSUE}" MATCHES ".*CentOS release 6\\.10 \\(Final\\).*" AND NOT "${LINUX_ISSUE}" MATCHES ".*CentOS Linux release 7\\.9.*") OR NOT EXISTS /usr/local/bin/auditwheel)
          MESSAGE(FATAL_ERROR "Python binary wheels for Linux platform must be compiled using the CentOS (6.10 or 7.9) docker images provided by the manylinux project from the Python Packaging Authority.\nSee https://github.com/pypa/manylinux for more details.")
	ENDIF()
	# build binaries with install rpath when generating Tulip Python wheels for Linux
	# as we don't install the project in that case
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
      ENDIF(APPLE)
    ENDIF(TULIP_ACTIVATE_PYTHON_WHEEL_TARGET)
  ENDIF(TULIP_BUILD_PYTHON_COMPONENTS)

  ## ========================================================
  ## Required packages
  ## ========================================================
  IF(MINGW)
    # Set some common libraries and headers search paths for MinGW
    SET(CMAKE_LIBRARY_PATH "${MINGW_BIN_PATH};${MINGW_LIB_PATH};${MINGW_LIB64_PATH};${CMAKE_LIBRARY_PATH}")
    SET(CMAKE_INCLUDE_PATH "${MINGW_INCLUDE_PATH};${MINGW_INCLUDE_PATH}/freetype2;${MINGW_INCLUDE_PATH}/libpng*;${CMAKE_INCLUDE_PATH}")
  ENDIF()

  # Don't need to find zlib when compiling with emscripten as there is an available emscripten port of it
  IF(NOT EMSCRIPTEN)
    # ZLIB
    FIND_PACKAGE(ZLIB REQUIRED)
  ENDIF(NOT EMSCRIPTEN)
ENDIF(NOT TRAVIS_BUILD_THIRDPARTY_ONLY)

# use thirdparty static libs when needed
IF(TULIP_ACTIVATE_PYTHON_WHEEL_TARGET OR TULIP_BUILD_FOR_APPIMAGE)
  SET(TULIP_USE_THIRDPARTY_STATIC_LIBS ON)
ELSE(TULIP_ACTIVATE_PYTHON_WHEEL_TARGET OR TULIP_BUILD_FOR_APPIMAGE)
  SET(TULIP_USE_THIRDPARTY_STATIC_LIBS OFF)
ENDIF(TULIP_ACTIVATE_PYTHON_WHEEL_TARGET OR TULIP_BUILD_FOR_APPIMAGE)

# Qhull
SET(TULIP_USE_THIRDPARTY_QHULL ${TULIP_USE_THIRDPARTY_STATIC_LIBS} CACHE BOOL "If activated, force the use of reentrant qhull library located in thirdparty instead of trying to find it on the system.")
IF(NOT TULIP_USE_THIRDPARTY_QHULL)
  FIND_PACKAGE(Qhull)
ELSE(NOT TULIP_USE_THIRDPARTY_QHULL)
  UNSET(QHULL_FOUND CACHE)
ENDIF(NOT TULIP_USE_THIRDPARTY_QHULL)

IF(NOT TULIP_BUILD_CORE_ONLY AND NOT TRAVIS_BUILD_THIRDPARTY_ONLY)
  # OpenGL
  FIND_PACKAGE(OpenGL REQUIRED)

  # Glew
  FIND_PACKAGE(GLEW REQUIRED)
  # if needed, when using cmake 3.15, define some undefined glew variables
  IF(NOT ${CMAKE_VERSION} VERSION_LESS "3.15.0")

=== doc/CMakeLists.txt ===
SET(TULIP_BUILD_DOC ON CACHE BOOL "Do you want to build the documentation ? [ON|OFF]")

#Only
IF(TULIP_BUILD_DOC)
  # Unset the previous values of the CMake cache variable SPHINX_EXECUTABLE
  # in case the value of Python_EXECUTABLE CMake variable changed
  # but save it before into D_SPHINX_EXECUTABLE to be able to restore it
  # in case there will be no other available
  SET(D_SPHINX_EXECUTABLE ${SPHINX_EXECUTABLE})
  UNSET(SPHINX_EXECUTABLE CACHE)
  IF(EXISTS ${D_SPHINX_EXECUTABLE})
    FIND_PACKAGE(Sphinx QUIET)
  ELSE(EXISTS ${D_SPHINX_EXECUTABLE})
    IF(D_SPHINX_EXECUTABLE)
      MESSAGE(FATAL_ERROR " SPHINX_EXECUTABLE ${D_SPHINX_EXECUTABLE} does not exist")
    ENDIF(D_SPHINX_EXECUTABLE)
    FIND_PACKAGE(Sphinx)
  ENDIF(EXISTS ${D_SPHINX_EXECUTABLE})
  IF(NOT SPHINX_FOUND AND (EXISTS ${D_SPHINX_EXECUTABLE}))
    # restore the previously defined value
    SET(SPHINX_FOUND TRUE)
    SET(SPHINX_EXECUTABLE ${D_SPHINX_EXECUTABLE} CACHE FILEPATH "Sphinx document generator" FORCE)
    MESSAGE("-- Found Sphinx: ${SPHINX_EXECUTABLE}")
  ENDIF(NOT SPHINX_FOUND AND (EXISTS ${D_SPHINX_EXECUTABLE}))
  IF(SPHINX_FOUND)
    IF(TULIP_BUILD_PYTHON_COMPONENTS)
      ADD_SUBDIRECTORY(python)
    ENDIF(TULIP_BUILD_PYTHON_COMPONENTS)
    ADD_SUBDIRECTORY(user)
    ADD_SUBDIRECTORY(developer)
  ELSE(SPHINX_FOUND)
    MESSAGE(AUTHOR_WARNING "Sphinx not found: unable to generate the documentation.")
  ENDIF(SPHINX_FOUND)

  IF(LINUX AND NOT TULIP_BUILD_FOR_APPIMAGE)
    FIND_PACKAGE(Doxygen)
    IF(DOXYGEN_FOUND)
      ADD_SUBDIRECTORY(doxygen)
    ELSE(DOXYGEN_FOUND)
      MESSAGE(AUTHOR_WARNING "doxygen not found: unable to generate the Tulip API documentation.")
    ENDIF(DOXYGEN_FOUND)
  ENDIF(LINUX AND NOT TULIP_BUILD_FOR_APPIMAGE)
ENDIF(TULIP_BUILD_DOC)

=== library/CMakeLists.txt ===
ADD_CORE_FILES(CMakeLists.txt)

ADD_SUBDIRECTORY(tulip-core)
IF(NOT TULIP_BUILD_CORE_ONLY)
  ADD_SUBDIRECTORY(tulip-ogl)
  ADD_SUBDIRECTORY(tulip-gui)
ENDIF(NOT TULIP_BUILD_CORE_ONLY)
IF(TULIP_BUILD_PYTHON_COMPONENTS)
  ADD_SUBDIRECTORY(tulip-python)
ENDIF(TULIP_BUILD_PYTHON_COMPONENTS)

=== software/CMakeLists.txt ===
ADD_SUBDIRECTORY(bitmaps)
ADD_SUBDIRECTORY(crash_handling)

# Override the CMAKE_RC_COMPILE_OBJECT variable to fix an issue with
# the windres compiler coming with binutils 2.32 on MSYS2
IF(WIN32 AND MINGW)
  SET(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> -O coff -o <OBJECT> <SOURCE>")
ENDIF(WIN32 AND MINGW)

ADD_SUBDIRECTORY(tulip_perspective)
IF(NOT TULIP_BUILD_FOR_APPIMAGE)
    ADD_SUBDIRECTORY(tulip)
    IF(TULIP_GENERATE_PLUGINSERVER)
     ADD_SUBDIRECTORY(plugin_server)
    ENDIF(TULIP_GENERATE_PLUGINSERVER)
ENDIF(NOT TULIP_BUILD_FOR_APPIMAGE)

=== tests/CMakeLists.txt ===
ADD_CORE_FILES(CMakeLists.txt)

FIND_PACKAGE(CppUnit REQUIRED)

MACRO(UNIT_TEST)
  SET(TEST_NAME ${ARGV0})
  UNSET(TEST_SRCS)
  FOREACH(loop_var ${ARGN})
    STRING(REGEX MATCH ".*\\.cpp" TEST_SRC_FILE ${loop_var})
    IF(TEST_SRC_FILE)
      SET(TEST_SRCS ${TEST_SRCS} ${loop_var})
    ENDIF(TEST_SRC_FILE)
  ENDFOREACH()
  # this is a cpp[unit] test
  IF(TEST_SRCS)
    INCLUDE_DIRECTORIES(${TulipCoreBuildInclude} ${TulipCoreInclude} ${CppUnit_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR}/tests/include)
    LINK_DIRECTORIES(${CppUnit_LIBRARY_DIRS})
    ADD_EXECUTABLE(${TEST_NAME} ${TEST_SRCS})
    ADD_DEPENDENCIES(runTests ${TEST_NAME})
    TARGET_LINK_LIBRARIES(${TEST_NAME} ${LibTulipCoreName} ${CppUnit_LIBRARIES})
    ADD_TEST(NAME ${TEST_NAME} COMMAND ${TEST_NAME} ${TEST_NAME})
  # otherwise this is a Python test
  ELSEIF(TULIP_BUILD_PYTHON_COMPONENTS)
    SET(PYTHON_TEST_MODULE ${ARGV1})
    FILE(COPY ${PYTHON_TEST_MODULE}.py DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
    ADD_TEST(NAME ${TEST_NAME} COMMAND ${Python_EXECUTABLE} -m unittest ${PYTHON_TEST_MODULE} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  ENDIF()
  # In order to run the tests on windows, we need to add the paths of the dll dependencies (cppunit, tulip, gzstream, yajl)
  # in the PATH environment variable
  IF(WIN32)
    IF(MINGW)
      STRING(REGEX MATCH ".*dll\\.a" IMPORT_LIBRARY ${CppUnit_LIBRARIES})
      STRING(REGEX MATCH ".*dll" DLL_LIBRARY ${CppUnit_LIBRARIES})
      IF(IMPORT_LIBRARY)
        TULIP_GET_DLL_NAME_FROM_IMPORT_LIBRARY(${CppUnit_LIBRARIES} CppUnitDllName)
      ELSEIF(DLL_LIBRARY)
        GET_FILENAME_COMPONENT(CppUnitDllName ${CppUnit_LIBRARIES} NAME)
      ENDIF()
    ELSE(MINGW)
      TULIP_GET_DLL_NAME_FROM_IMPORT_LIBRARY(${CppUnit_LIBRARIES} CppUnitDllName)
    ENDIF(MINGW)
    IF(CppUnitDllName)
      TULIP_FIND_EXTERNAL_LIB(${CppUnitDllName} CppUnitDllPath)
      IF(CppUnitDllPath)
        GET_FILENAME_COMPONENT(CppUnitDllDir ${CppUnitDllPath} DIRECTORY)
      ENDIF(CppUnitDllPath)
    ENDIF()
    SET(NEWPATH "${CppUnitDllDir};${CMAKE_LIBRARY_PATH};${QT_BINARY_DIR};${PYTHON_HOME_PATH};${CMAKE_BINARY_DIR}/thirdparty/gzstream/;${CMAKE_BINARY_DIR}/thirdparty/yajl/src;${CMAKE_BINARY_DIR}/thirdparty/ftgl")
    SET(NEWPATH "${NEWPATH};${CMAKE_BINARY_DIR}/library/tulip-core/src;${CMAKE_BINARY_DIR}/library/tulip-ogl/src;${CMAKE_BINARY_DIR}/library/tulip-gui/src;$ENV{PATH}")
    SET(NEWPATH "${NEWPATH};${CMAKE_BINARY_DIR}/thirdparty/libtess2;${CMAKE_BINARY_DIR}/thirdparty/OGDF;${CMAKE_BINARY_DIR}/library/tulip-ogdf;${CMAKE_BINARY_DIR}/library/tulip-python/src;$ENV{PATH}")
    STRING(REPLACE "\\;" ";" NEWPATH "${NEWPATH}")
    STRING(REPLACE ";" "\\;" NEWPATH "${NEWPATH}")
  ELSE(WIN32)
    SET(NEWPATH "$ENV{PATH}")
  ENDIF(WIN32)
  # add Tulip modules path to PYTHONPATH in order to run the Python tests
  SET(PYTHONPATH "${CMAKE_BINARY_DIR}/library/tulip-python/modules/;${TULIP_PYTHON_ROOT_FOLDER};${TULIPGUI_PYTHON_ROOT_FOLDER};${CMAKE_BINARY_DIR}/thirdparty/sip-${SIP_VERSION_STR}/siplib")
  IF(WIN32)
    STRING(REPLACE "\\;" ";" PYTHONPATH "${PYTHONPATH}")
    STRING(REPLACE ";" "\\;" PYTHONPATH "${PYTHONPATH}")
  ELSE(WIN32)
    STRING(REPLACE ";" ":" PYTHONPATH "${PYTHONPATH}")
  ENDIF(WIN32)
  # set tests environment
  SET_TESTS_PROPERTIES(${TEST_NAME} PROPERTIES ENVIRONMENT "TULIP_BUILD_DIR=${CMAKE_BINARY_DIR};PYTHONPATH=${PYTHONPATH};PATH=${NEWPATH}")
ENDMACRO(UNIT_TEST)

ADD_SUBDIRECTORY(library)

IF(TULIP_BUILD_PYTHON_COMPONENTS)
  ADD_DEPENDENCIES(runTests copyTulipPluginsPyInBuild)
ENDIF(TULIP_BUILD_PYTHON_COMPONENTS)

IF(NOT TULIP_BUILD_CORE_ONLY)
  ADD_SUBDIRECTORY(plugins)
ENDIF(NOT TULIP_BUILD_CORE_ONLY)

IF(TULIP_BUILD_PYTHON_COMPONENTS)
  ADD_SUBDIRECTORY(python)
ENDIF(TULIP_BUILD_PYTHON_COMPONENTS)

ADD_SUBDIRECTORY(external_plugins_build)

=== thirdparty/CMakeLists.txt ===
DISABLE_COMPILER_WARNINGS()

ADD_CORE_FILES(CMakeLists.txt
               utf8-cpp/source/utf8.h
               utf8-cpp/source/utf8/checked.h
               utf8-cpp/source/utf8/core.h
               utf8-cpp/source/utf8/unchecked.h
)

ADD_SUBDIRECTORY(gzstream)
ADD_SUBDIRECTORY(OGDF)

IF(NOT QHULL_FOUND)
  IF (TULIP_USE_THIRDPARTY_STATIC_LIBS)
    MESSAGE(STATUS "Qhull static library located in thirdparty will be used.")
  ELSE()
    MESSAGE(STATUS "Qhull library was not found on the system, the static version located in thirdparty will be used.")
  ENDIF()
  ADD_SUBDIRECTORY(libqhull)
ENDIF(NOT QHULL_FOUND)
ADD_SUBDIRECTORY(yajl)

ADD_SUBDIRECTORY(antlr)
ADD_SUBDIRECTORY(xdkbibtex)

IF(NOT TULIP_BUILD_CORE_ONLY AND NOT TRAVIS_BUILD_THIRDPARTY_ONLY)
  ADD_SUBDIRECTORY(ftgl)
  ADD_SUBDIRECTORY(libtess2)
  IF (NOT LIBZIP_FOUND)
    MESSAGE(STATUS "libzip static library located in third party will be used")
    ADD_SUBDIRECTORY(libzip)
  ENDIF(NOT LIBZIP_FOUND)
ENDIF(NOT TULIP_BUILD_CORE_ONLY AND NOT TRAVIS_BUILD_THIRDPARTY_ONLY)
IF(Python_FOUND)
  IF(SIP_OK AND NOT SIP_FOUND)
    ADD_SUBDIRECTORY(sip-${SIP_VERSION_THIRDPARTY})
  ENDIF(SIP_OK AND NOT SIP_FOUND)
ENDIF(Python_FOUND)

=== bundlers/win/CMakeLists.txt ===
IF(TULIP_BUILD_PYTHON_COMPONENTS)
  IF(IS_64BIT)
    SET(PYTHON_INSTALLER "python-${PYTHON_VERSION_WITH_PATCH}-amd64.exe")
  ELSE()
    SET(PYTHON_INSTALLER "python-${PYTHON_VERSION_WITH_PATCH}.exe")
  ENDIF()
  SET(PYTHON_INSTALLER_EXT "exe")
ENDIF()

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/Tulip.nsi.in ${CMAKE_CURRENT_BINARY_DIR}/Tulip.nsi @ONLY)

=== doc/python/CMakeLists.txt ===
IF(Python_FOUND AND SIP_OK)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in ${CMAKE_CURRENT_BINARY_DIR}/conf.py)

# On windows, it is required that the paths to the dll dependencies (e.g. zlib, libpng, ...) are contained
# in the CMAKE_LIBRARY_PATH variable (especially with Visual Studio).
# Some warnings will be output when configuring the whole project if it is not the case.
# Otherwise, the Python API documentation will not be generated as the import of the tulip modules will fail.

# Turn CMAKE_LIBRARY_PATH list into a string in order to pass all its contents to the CMake command generating the doc,
# only the first list entry is transferred otherwise.
STRING(REPLACE ";" "," CMAKE_LIBRARY_PATH_STR "${CMAKE_LIBRARY_PATH}")

# Ensure that libraries paths are in MSYS format when using MSYS Makefiles,
# otherwise the documentation fails to build
IF("${CMAKE_GENERATOR}" MATCHES ".*MSYS.*")
  TULIP_WINDOWS_TO_MSYS_PATH(${CMAKE_LIBRARY_PATH_STR} CMAKE_LIBRARY_PATH_STR)
ENDIF("${CMAKE_GENERATOR}" MATCHES ".*MSYS.*")

# copy .py files in CMAKE_CURRENT_BINARY_DIR
# in order to avoid polluting the source tree with python .pyc files
FILE(GLOB PYFILES *.py)
FILE(COPY ${PYFILES} DESTINATION .)

ADD_CUSTOM_TARGET(pythonBindingsDoc ALL ${CMAKE_COMMAND} -DSPHINX_EXECUTABLE=${SPHINX_EXECUTABLE}
                                                         -DPython_EXECUTABLE=${Python_EXECUTABLE}
                                                         -DSRC_DIR=${CMAKE_CURRENT_SOURCE_DIR}
                                                         -DBIN_DIR=${CMAKE_CURRENT_BINARY_DIR}
                                                         -DTULIP_SOURCE_DIR=${CMAKE_SOURCE_DIR}
                                                         -DTULIP_BUILD_DIR=${CMAKE_BINARY_DIR}
                                                         -DSYSTEM_SIP=${SYSTEM_SIP} -DSIP_VERSION=${SIP_VERSION_STR}
                                                         -DQT_BIN_DIR=${QT_BINARY_DIR}
                                                         -DAPPLE=${APPLE} -DWIN32=${WIN32}
                                                         -DCMAKE_LIBRARY_PATH=${CMAKE_LIBRARY_PATH_STR}
                                                         -P ${CMAKE_CURRENT_SOURCE_DIR}/genSphinxDoc.cmake
                                    DEPENDS ${LibTulipCorePythonBindingsName}
                                            ${LibTulipGUIPythonBindingsName}
                                            ${LibStlPythonBindingsName}
                                            ${TULIP_PLUGIN_TARGETS}
                                            copyTulipPythonPlugins
					    copyTulipPluginsPyInBuild
                                    VERBATIM)

SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "doc;doctrees") 

INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html 
        DESTINATION ${CMAKE_INSTALL_DOCDIR}/tulip-python
        COMPONENT tulip_python_doc)

ENDIF(Python_FOUND AND SIP_OK)

=== library/tulip-gui/CMakeLists.txt ===
IF(WIN32)
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DDLL_TULIP_QT")
ENDIF(WIN32)


INSTALL(DIRECTORY samplePictures colorscales
        DESTINATION ${TulipBitmapInstallDir})

ADD_SUBDIRECTORY(include)
ADD_SUBDIRECTORY(src)

=== library/tulip-python/CMakeLists.txt ===
IF(MINGW AND X86_64)
  ADD_COMPILE_DEFINITIONS(MS_WIN64)
ENDIF(MINGW AND X86_64)

# VS2013 and beyond implement C99 math functions.  Of interest to Python is the function round().
# Python conditionally provides its own implementation of round() based on whether or not HAVE_ROUND is defined, but in no case is HAVE_ROUND ever defined.
# This leads to a huge spew of warnings when compiling with VS2013, and presumably it also leads to undefined behavior.
# So define HAVE_ROUND for that compiler.
IF(MSVC12)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_ROUND")
ENDIF(MSVC12)

ADD_COMPILE_DEFINITIONS(SIP_MODULE=${SIP_MODULE})

ADD_CORE_FILES(CMakeLists.txt)

ADD_SUBDIRECTORY(modules)
ADD_SUBDIRECTORY(bindings)
ADD_SUBDIRECTORY(plugins)

# libtulip-python is not needed when not building tulip gui
IF(NOT TULIP_BUILD_CORE_ONLY)
  ADD_SUBDIRECTORY(api)
  ADD_SUBDIRECTORY(include)
  ADD_SUBDIRECTORY(src)
ENDIF(NOT TULIP_BUILD_CORE_ONLY)

=== plugins/clustering/CMakeLists.txt ===
ADD_CORE_DIRECTORY_EXCEPT(ConvolutionClustering*.*)

INCLUDE_DIRECTORIES(${TulipCoreBuildInclude} ${TulipCoreInclude} ${CMAKE_CURRENT_BINARY_DIR})

ADD_SUBDIRECTORY(Delaunay)

##----------------------------------------------------------------------------------------------------------------------------
SET(StrengthClustering_SRCS
  StrengthClustering.h
  StrengthClustering.cpp)

ADD_LIBRARY(StrengthClustering-${Tulip_VERSION} SHARED ${StrengthClustering_SRCS})
TARGET_LINK_LIBRARIES(StrengthClustering-${Tulip_VERSION} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(HierarchicalClustering_SRCS
  HierarchicalClustering.cpp
  HierarchicalClustering.h)

ADD_LIBRARY(HierarchicalClustering-${Tulip_VERSION} SHARED ${HierarchicalClustering_SRCS})
TARGET_LINK_LIBRARIES(HierarchicalClustering-${Tulip_VERSION} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(CliqueEnumeration_SRCS
  CliqueEnumeration.cpp
  CliqueEnumeration.h)

ADD_LIBRARY(CliqueEnumeration-${Tulip_VERSION} SHARED ${CliqueEnumeration_SRCS})
TARGET_LINK_LIBRARIES(CliqueEnumeration-${Tulip_VERSION} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
IF(NOT TULIP_BUILD_CORE_ONLY)
QTX_SET_INCLUDES_AND_DEFINITIONS()

QTX_WRAP_UI(ConvolutionClustering_UI_SRCS
  ConvolutionClusteringSetup.ui)

QTX_WRAP_CPP(ConvolutionClustering_MOC_SRCS
  ConvolutionClusteringSetup.h)

SET(ConvolutionClustering_SRCS
  ConvolutionClustering.h
  ConvolutionClustering.cpp
  ConvolutionClusteringSetup.cpp
  ConvolutionClusteringSetup.h)

ADD_LIBRARY(ConvolutionClustering-${Tulip_VERSION} SHARED ${ConvolutionClustering_SRCS} ${ConvolutionClustering_UI_SRCS} ${ConvolutionClustering_MOC_SRCS})
TARGET_LINK_LIBRARIES(ConvolutionClustering-${Tulip_VERSION} ${LibTulipCoreName} ${QT_LIBRARIES})
ENDIF(NOT TULIP_BUILD_CORE_ONLY)
##----------------------------------------------------------------------------------------------------------------------------
SET(EqualValueClustering_SRCS
  EqualValueClustering.h
  EqualValueClustering.cpp)

ADD_LIBRARY(EqualValueClustering-${Tulip_VERSION} SHARED ${EqualValueClustering_SRCS})
TARGET_LINK_LIBRARIES(EqualValueClustering-${Tulip_VERSION} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
SET(QuotientClustering_SRCS
    QuotientClustering.cpp
)

ADD_LIBRARY(QuotientClustering-${Tulip_VERSION} SHARED ${QuotientClustering_SRCS})
TARGET_LINK_LIBRARIES(QuotientClustering-${Tulip_VERSION} ${LibTulipCoreName})

##----------------------------------------------------------------------------------------------------------------------------
TULIP_INSTALL_PLUGIN(StrengthClustering-${Tulip_VERSION} ${TulipPluginsInstallDir})
TULIP_INSTALL_PLUGIN(HierarchicalClustering-${Tulip_VERSION} ${TulipPluginsInstallDir})
IF(NOT TULIP_BUILD_CORE_ONLY)
TULIP_INSTALL_PLUGIN(ConvolutionClustering-${Tulip_VERSION} ${TulipPluginsInstallDir})
ENDIF(NOT TULIP_BUILD_CORE_ONLY)
TULIP_INSTALL_PLUGIN(EqualValueClustering-${Tulip_VERSION} ${TulipPluginsInstallDir})
TULIP_INSTALL_PLUGIN(QuotientClustering-${Tulip_VERSION} ${TulipPluginsInstallDir})
TULIP_INSTALL_PLUGIN(CliqueEnumeration-${Tulip_VERSION} ${TulipPluginsInstallDir})

=== plugins/glyph/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${TulipCoreBuildInclude} ${TulipCoreInclude} ${TulipOGLInclude} ${GLEW_INCLUDE_DIR} ${FTGLInclude} ${FREETYPE_INCLUDE_DIRS})

MACRO(GLYPH name source)
  ADD_LIBRARY(${name}-${Tulip_VERSION} SHARED ${source})
  TARGET_LINK_LIBRARIES(${name}-${Tulip_VERSION} ${LibTulipCoreName} ${LibTulipOGLName})
  TULIP_INSTALL_PLUGIN(${name}-${Tulip_VERSION} ${TulipGlyphPluginsInstallDir})
ENDMACRO(GLYPH)

GLYPH(Cone cone.cpp)

GLYPH(Circle circle.cpp)
GLYPH(Sphere sphere.cpp)

GLYPH(Square square.cpp)
GLYPH(RoundedBox roundedbox.cpp)
GLYPH(Cube cube.cpp)

GLYPH(Window window.cpp)
GLYPH(Hexagone hexagone.cpp)
GLYPH(Triangle triangle.cpp)
GLYPH(Pentagone pentagone.cpp)
GLYPH(CubeOutlinedTransparent cubeoutlinedtransparent.cpp)
GLYPH(Ring ring.cpp)
GLYPH(Billboard billboard.cpp)
GLYPH(Cylinder cylinder.cpp)
GLYPH(Diamond diamond.cpp)
GLYPH(Cross cross.cpp)
GLYPH(GlowSphere glowsphere.cpp)
GLYPH(ShadowedSphere shadowedsphere.cpp)
GLYPH(Star star.cpp)
GLYPH(FontIcon fonticon.cpp)

INSTALL(FILES radialGradientTexture.png bottomShadowTexture.png leftBottomShadowTexture.png rightBottomShadowTexture.png
        DESTINATION ${TulipBitmapInstallDir}
        COMPONENT tulip_plugins)

=== PKGBUILD ===
# Maintainer: Antoine Lambert <antoine.lambert@inria.fr>

_realname=tulip
pkgbase="mingw-w64-${_realname}"
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=5.7.4
pkgrel=3
pkgdesc="Large graphs analysis, drawing and visualization framework (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url="https://tulip.labri.fr/"
license=('spdx:LGPL-3.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-libzip"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-qhull"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-5compat"
         #"${MINGW_PACKAGE_PREFIX}-yajl"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             #"${MINGW_PACKAGE_PREFIX}-sip" requires sip4
             "${MINGW_PACKAGE_PREFIX}-python-sphinx"
             "${MINGW_PACKAGE_PREFIX}-python-setuptools")
source=("https://sourceforge.net/projects/auber/files/tulip/${_realname}-${pkgver}/${_realname}-${pkgver}_src.tar.gz"
        "001-fix-tulip-python-install.patch"
        "002-fix-template-instatiation.patch"
        "003-fix-clang-omp-link.patch"
        "004-fix-tulip-core-headers.patch"
        "005-fix-cmakelists.patch"
        "006-fix-build-with-qt6.patch"
        "007-find-shared-qhull.patch"
        # https://github.com/frankheckenbach/ftgl/commit/d546aefd
        "008-fix-build-ftgl-with-gcc-14.patch")
sha256sums=('ef3db55a43e2d6fd801a2b210e65d93c079d3238173d19e95221d3cc49dce4b6'
            '90418ac3795d100f6c550011800e129165cecf9a07ca9a619633a5b4322f5df6'
            '8572c14d233a9026fcc984ab9d94e1c8230eadee63ff2eaeed6ad01e5063610b'
            '20bc5ed1744505ab89a4aec597e5286451d37c49241b8a784e0a51957f43dc7b'
            'ace5318108e15b61202440e112ed2ac81d49dd44fa5d6cc3766f09da8299b6b5'
            '32193596196c0eda8a2989bd4467a22c7daf3eaaba3d51d88f0de11b50ba543d'
            '238d4e0400a17ac7d4a8277c5467a01a1a6124df3df64119d9b7d09eb583d1c5'
            '3e0bc0f97ea37643cb471bf7893ac3c7803bc932abec457875a2fcaac97ed119'
            '922ab11b1863f559f83c250acbe0c0379eaadb8a60178bf569f92daa406a055a')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}"/${_patch}
  done
}

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"
  apply_patch_with_msg \
    001-fix-tulip-python-install.patch \
    002-fix-template-instatiation.patch \
    003-fix-clang-omp-link.patch \
    004-fix-tulip-core-headers.patch \
    005-fix-cmakelists.patch \
    006-fix-build-with-qt6.patch \
    007-find-shared-qhull.patch \
    008-fix-build-ftgl-with-gcc-14.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CC} == gcc ]]; then
    CXXFLAGS+=" -Wno-template-id-cdtor"
  else
    CXXFLAGS+="  -Wno-dtor-name"
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    "${_extra_config[@]}" \
    -DCMAKE_NEED_RESPONSE=ON \
    -DCMAKE_SYSTEM_IGNORE_PATH=/usr/lib \
    -DTULIP_FIXUP_BUNDLE=OFF \
    -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python3.exe \
    -DTULIP_PYTHON_SITE_INSTALL=ON \
    -DTULIP_USE_QT6=ON \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/COPYING "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/COPYING
  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/COPYING.LESSER "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/COPYING.LESSER
}
